<?php

	////////////////////////////////////////////////////////
	//
	//	Constants are returned using functions, because
	//  global variables are turned off, for some 
	//	security concerns - Imran Salim
	
	function CONST_CODE_VERSION()
	{
		return 1.0;
	}
	
	function CONST_XML_NAMESPACE ()
	{
		return "http://www.w3.org/2001/XMLSchema-instance";
	}
	
	function CONST_FTP_HP_URL()
	{
		// For testing, change server name to such
		// thing as - return "ensdadvtech";
		return "ftp.hp.com";
	}
	
	function CONST_DATAPROTECTION()
	{
		return "DataProtection";
	}
	
	function CONST_FTP_HP_USERNAME()
	{
		return "anonymous";
	}
	
	function CONST_FTP_HP_PASSWORD()
	{
		return "guest@hewlettpackard.com";
	}
	
	function CONST_XML_FILE_DATA_PROTECTION()
	{
		if ( !strcmp(CONST_LANG(), "ja"))		
			return  CONST_DIR_DATA_PROTECTION()."/Xml/ProtectYourData.jpn.xml";
		else // Default is English
			return  CONST_DIR_DATA_PROTECTION()."/Xml/ProtectYourData.xml";
	}
	
	function CONST_XSD_FILE_DATA_PROTECTION()
	{
		 return  CONST_DIR_DATA_PROTECTION()."/Xml/ProtectYourData.xsd";
	}

	function CONST_XML_URL_DATA_PROTECTION()
	{
		if ( !strcmp(CONST_LANG(), "ja"))
			return "/pub/tape/ProtectYourData.jpn.xml";
		else // Default is English
		 	return "/pub/tape/ProtectYourData.xml";
	}
	
	function CONST_XSD_URL_DATA_PROTECTION()
	{
		 return "/pub/tape/ProtectYourData.xsd";
	}
	
	function CONST_XML_FTP_UPDATE_DELTA_TIME()
	{ 	// Unit in seconds - Used to determine delta time to check for
		//	 updates on ftp side about downloading software.
		// This delta time does not currently apply to xml file.
		// return 3600 /* 1 hour */;
		// return 1 /* 1 second */;
		return 10 /* 10 second */;
	}

	function CONST_XML_FILE_TMP_DATA_PROTECTION()
	{
		if ( !strcmp(CONST_LANG(), "ja"))
			return  CONST_DIR_DATA_PROTECTION()."/Xml/TmpProtectYourData.jpn.xml";
		else // Default is English
			return  CONST_DIR_DATA_PROTECTION()."/Xml/TmpProtectYourData.xml";
	}

	function CONST_XSD_FILE_TMP_DATA_PROTECTION()
	{
		 return  CONST_DIR_DATA_PROTECTION()."/Xml/TmpProtectYourData.xsd";
	}

	function CONST_XML_FILE_SOFTWARE_DEPLOYMENT()
	{
		return  CONST_DIR_DATA_PROTECTION()."/Xml/SoftwareDeployment.xml";		
	}
	
	function CONST_XML_SCHEMA_SOFTWARE_DEPLOYMENT()
	{
		return  CONST_DIR_DATA_PROTECTION()."/Xml/SoftwareDeployment.xsd";
	}
	
	function CONST_XML_OUTPUT_SOFTWARE_DEPLOYMENT()
	{
		return  CONST_DIR_DATA_PROTECTION()."/Xml/Output#SoftwareDeployment.xml";
	}
	
	
	
	function CONST_DIR_DATA_PROTECTION()
	{
		return $_SERVER['DOCUMENT_ROOT']."/DataProtection";
	}
	
	function CONST_DIR_SERVER_DOWNLOAD()
	{
		return CONST_DIR_DATA_PROTECTION()."/Server";
	}

	
	
	
	
	function CONST_URL_DATA_PROTECTION()
	{
		return "/DataProtection";
	}
	
	function CONST_URL_SERVER_DOWNLOAD()
	{
		return CONST_URL_DATA_PROTECTION()."/Server/DownloadServer.php";
	}
	
	function CONST_URL_SERVER_INSTALL()
	{
		return CONST_URL_DATA_PROTECTION()."/Server/InstallServer.php";
	}
	
	function CONST_URL_UPDATE_XML()
	{
		return CONST_URL_DATA_PROTECTION()."/Xml/UpdateServer.php";
	}
	
	function CONST_URL_IMAGE()
	{
		return  CONST_URL_DATA_PROTECTION()."/Image";
	}

	
	function CONST_URL_TRACKING_QUERY_PARAMETER ()
	{
		return "jumpid=nearline";
	}

	
	
	
	function CONST_OS_WINDOWS()
	{
		return "Windows";
	}
	
	function CONST_OS_LINUX()
	{
		return "Linux";
	}
	
	function CONST_LANG()
	{
		$svrlang = substr($_SERVER["HTTP_ACCEPT_LANGUAGE"],0,2);
		if ( !strcmp($svrlang, "ja"))
		 	return  $svrlang;
		 
		if (!strcmp($_GET[lang], "ja"))
          	return $svrlang;
        else
          	return substr($_GET[lang],0,2);
	}
	
	
	function CONST_FORM_MAIN()
	{
		return "MainForm";
	}

	
	
	function CONST_IS_FTP_CHECKED_FOR_XML()
	{
		return "IsFtpCheckedForXml";
	}
	
	function CONST_DEBUG()
	{
		return false;
	}
?>