<?php
session_start();
include "iocommand.php";
include "fefunctions.php";


   /***********************************************************************
   *    Copyright  2002 - 2005 Hewlett-Packard Development Company, L.P. *
   ***********************************************************************/
?>
<html>
  <head>
    <meta http-equiv='content-type' content='text/html; charset=UTF-8'>
    <link rel='stylesheet' type='text/css' href='stylesheets/main.css'>
    <link rel='stylesheet' type='text/css' href='stylesheets/header.css'>
    <SCRIPT LANGUAGE='JavaScript' SRC='menufunctions.js'>\n</SCRIPT>    
    <SCRIPT LANGUAGE='JavaScript' SRC='dom-drag.js'></SCRIPT>
    <script language="Javascript">
      function initPage()
      {
	      theHandle = document.getElementById("handleIt");
	      theRoot   = document.getElementById("rootIt");
	      Drag.init(theHandle, theRoot);
      }
    </script>
    
  </head>
  <body onload="initPage();" topmargin=0 MARGINHEIGHT=0>

<?php
$oss = "";  
$oss = $oss . sprintf("<table width=100%% height=100%% cellspacing=0 cellpadding=0 border=0>\n");
$oss = $oss . sprintf("    <tr>\n      <td width=15>&nbsp;</td>\n      <td bgcolor=#cccccc width=6>&nbsp;</td>\n      <td valign=top>\n");


if ($HTTP_POST_VARS["device"] != "" && $HTTP_POST_VARS["globActionNum"] != "") // submit deviceAction
{
  $globActionName = sprintf("%s%s",$HTTP_POST_VARS["device"],$HTTP_POST_VARS["globActionNum"]);
  $actionCmd = sprintf("%s", $_SESSION[$globActionName]);
  //$actionCmd = sprintf("%s", $HTTP_POST_VARS["action"]);
  //echo htmlentities($actionCmd); 
  ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $actionCmd, $result, $idErrors);
  //echo htmlentities($result);
}
$oss = $oss . sprintf("<div style='height:385px;overflow:auto'>\n<table width=100%%>\n"); 
$xmldoc = new DomDocument($_SESSION["diagnosisResult"]);   
//echo htmlentities($xmldoc->html_dump_mem());
$diagOutputXpath = @xpath_new_context($xmldoc->document_element());
$diagOuputs = @xpath_eval($diagOutputXpath, "/diagOutput/diagnosisResult");
$num_of_diagOuputs = count($diagOuputs->nodeset);
for ($a=0; $a < $num_of_diagOuputs; $a++)
{
  $diagOutput = $diagOuputs->nodeset[$a];
  
  $diagOutputCaption = $diagOutput->get_attribute("caption");
  $oss = $oss . sprintf("<tr><td class=heading>%s</td></tr>\n", $diagOutputCaption);
  $diagOutputXpath = xpath_new_context($diagOutput);
  $diagnosisResults = xpath_eval($diagOutputXpath, "/diagnosisResult");
  $num_diagnosisResults = count($diagnosisResults->nodeset);
  for ($b=0; $b < $num_diagnosisResults; $b++)
  {
    $diagnosisResult = $diagnosisResults->nodeset[$b];
    $currentState = $diagnosisResult->get_attribute("currentState");
    $drCaption = $diagnosisResult->get_attribute("caption");
    $device = $diagnosisResult->get_attribute("device");
    $component = $diagnosisResult->get_attribute("component");
    $oss = $oss . sprintf("<tr><td class='subhead'>%s</td></tr>\n", $drCaption);

    if ($currentState == "passed")
    {
      $oss = $oss . sprintf("<tr><td style='padding-left:15px'><img src='ok.gif'> &nbsp;&nbsp;%s</td></tr>\n", TR("MSG_PASSED"));
    }
    else if ($currentState == "unavailable")
    {
      $infos = $diagnosisResult->get_elements_by_tagname("info");
      $infoCaption = $infos[0]->get_attribute("caption");
      $oss = $oss . sprintf("<tr><td style='padding-left:15px'><img src='white_status_unknown_15.png'> %s</td></tr>\n", $infoCaption);
    }
    else if ($currentState == "failed")
    {
      $errors = $diagnosisResult->get_elements_by_tagname("error");
      $num_errors = count($errors);
      for ($c=0; $c < $num_errors; $c++)
      {
        $error = $errors[$c];
        $errorContent = $error->get_attribute("caption");
        $time = $error->get_attribute("time");
        $errorCode = $error->get_attribute("errorCode");
        $oss = $oss . sprintf("<tr><td style='padding-left:15px'><img src='failed.gif'> &nbsp;&nbsp;%s&nbsp;&nbsp;&nbsp;%s</td></tr>\n", TR("MSG_FAILED"), $time);
        $oss = $oss . sprintf("<tr><td style='padding-left:25px'>%s: %s</td></tr>\n", $errorCode, $errorContent);
        /*
        $repairActions = $error->get_elements_by_tagname("repairAction");
        $num_repairActions = count($repairAction);
        for ($d=0; $d < $num_repairAction; $d++)
        {
          $repairContent = $repairAction[$d]->get_content();
          $oss = $oss . sprintf("<tr><td style='padding-left:25px'><li>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;%s</td><tr>\n", $repairContent);
        }
        */
      }                  
    }
    
    $formattedFiles = $diagnosisResult->get_elements_by_tagname("formattedTextFile");
    $num_formattedFiles = count($formattedFiles);
    for ($f=0; $f < $num_formattedFiles; $f++)
    {
      $formattedFile = $formattedFiles[$f];
      $filename = $formattedFile->get_attribute("filename");
      $formattedContent = @file_get_contents($_SESSION["diagsDirectory"] . GetLanguage() . SL() . $filename);
      $oss = $oss . sprintf("<tr><td style='padding-left:25px'>%s</td><tr>", $formattedContent);           
    }
    
    $diagnosisResultXpath = @xpath_new_context($diagnosisResult);
    
    $infos = @xpath_eval($diagnosisResultXpath, "/info");
    $num_infos = count($infos->nodeset);
    for ($i=0;$i < $num_infos; $i++)
    {
      $oss = $oss . sprintf("<tr><td style='padding-left:25px'>%s</td></tr>\n", $infos->nodeset[$i]->get_content());
    }
    $deviceActions = @xpath_eval($diagnosisResultXpath, "/deviceAction");
    
    //$deviceActions = $diagnosisResult->get_elements_by_tagname("deviceAction");
    $num_deviceActions = count($deviceActions->nodeset);
    if ($num_deviceActions)                             
      $oss = $oss . sprintf("<tr><td style='padding-left:25px;'>\n<table>\n<tr>\n");
    for ($da=0; $da < $num_deviceActions; $da++)
    {
      $deviceAction = $deviceActions->nodeset[$da];
      $caption = $deviceAction->get_attribute("caption");
      $deviceAction->set_attribute("component", $component);
      $deviceAction->set_attribute("tcLoadFilename", $component.".dat");
      $childnodes = $deviceAction->child_nodes();
      $formName = $device. "Action" . $da . "Form";
      $oss = $oss . sprintf("<td><form name=%s method=POST>%s",$formName, MakeButton($caption, "document.".$formName.".submit();"));
      $oss = $oss . sprintf("<input type=hidden name='device' value='%s'><input type=hidden name='component' value='%s'><input type='hidden' name='globActionNum' value='%s'>",$device,$component,$da);

      $globAction = sprintf("%s%s", $device, $da);
      $_SESSION[$globAction] = my_dump_node($deviceAction, "ISO-8859-1");
      $oss = $oss . sprintf("</form>\n</td>\n");
    }
    if ($num_deviceActions)
      $oss = $oss . sprintf("</tr>\n</table>\n</td></tr>");
  }     
}
$oss = $oss . sprintf("</table></div> ");

$oss = $oss . sprintf(" </td>\n    <td width=6 bgcolor=#cccccc>&nbsp;</td>\n    <td width=10>&nbsp;</td>\n  </tr>\n  <tr>\n    <td width=15 height=5></td>\n    <td colspan=3 bgcolor=#cccccc height=5></td>\n    <td width=10 height=5></td>\n  </tr>\n  <tr>\n    <td width=15 height=35>&nbsp;</td>\n    <td colspan=3>\n");

$oss = $oss . sprintf("<table border=0 width=100%%>\n<tr>\n<td width=150>%s</td><td align=right>%s</td><td width=60>%s</td>\n</tr>\n</table>\n", MakeButton(TR("MSG_EXIT") ." ". TR("MSG_DIAGNOSTICS"), "parent.parent.frames.headerFrame.exit();"), MakeButton(TR("MSG_PRINT"), "window.print();"), MakeButton(TR("MSG_SAVE"), "document.getElementById('rootIt').style.display = 'inline';document.getElementById('rootIt').style.visibility = 'visible';"));
$oss = $oss . sprintf("\n");

$oss = $oss . sprintf(" </td>\n    <td width=10 height=35>&nbsp;</td>    \n  </tr>\n</table>");


if ($HTTP_POST_VARS["save"] == "3")  
{ // Save page

  $result = SaveFile($HTTP_POST_VARS["filename"],$HTTP_POST_VARS["saveLocation"], "HP Insight Diagnostics " . TR("MSG_VERSION") . " " . getBuildVersion() . "<br>" . TR("Computer Name") . ": " . getComputerName() . $oss);

  if ($result == 1 || $result == 3)
    $oss = $oss . sprintf("<script language='Javascript'>\nalert('%s - %s');\n</script>\n", TR("MSG_WRITEERROR"), TR("MSG_PLEASE_CHECK_MEDIA"));
  else if ($result == 2)
    $oss = $oss . sprintf("<script language='Javascript'>\nalert('%s - %s');\n</script>\n", TR("MSG_WRITEERROR"), TR("MSG_DISK_FULL"));
  else if ($result == 4)
    $oss = $oss . sprintf("<script language='Javascript'>\nalert('%s - %s');\n</script>\n", TR("MSG_WRITEERROR"), TR("MSG_BAD_FORMAT"));
  else
    $oss = $oss . sprintf("<script language='Javascript'>\nalert('%s');\n</script>\n", TR("MSG_FILE_WRITE_COMPLETE"));
}


$oss = $oss . sprintf("<SCRIPT Language='Javascript'>\n");
$oss = $oss . sprintf("function saveFile(s)\n{\n");
$oss = $oss . sprintf("  if (s == 2 && (document.diagnosisResultForm.filename.value == '' || document.diagnosisResultForm.filename.value == '.html' || document.diagnosisResultForm.filename.value == '.htm'))\n{\n");
$oss = $oss . sprintf("  alert('%s');\n", TR("MSG_PLEASE_ENTER_FILENAME"));
$oss = $oss . sprintf("    return;\n }\n");

$element=1;
if (IsOnline())
{
$oss = $oss . sprintf("    if (document.getElementById('hdrivelocation').checked)\n{\ndocument.diagnosisResultForm.saveLocation.value = 'harddrive';\n}\n", $element);
$element++;
}

if ($diskonkey)
{
$oss = $oss . sprintf("    if (document.getElementById('diskonkeylocation').checked)\ndocument.diagnosisResultForm.saveLocation.value = 'diskonkey';\n", $element);
$element++;
}

if ($usbFloppy)
{
$oss = $oss . sprintf("    if (document.getElementById('usblocation').checked)\ndocument.diagnosisResultForm.saveLocation.value = 'usb';\n", $element);
$element++;
}

$oss = $oss . sprintf("  document.diagnosisResultForm.save.value = s;\n");
$oss = $oss . sprintf("  document.diagnosisResultForm.submit();\n}\n");


if ($HTTP_POST_VARS["save"] == "2")  // check if file exits
{
if ($HTTP_POST_VARS["saveLocation"] == "floppy")
{
  if ($os == "Linux" || $os == "Unix")
    ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", "<systemCall>mount " . getPathToFloppy() . "</systemCall>", $returnString, $systemCallError);
  $fileP = getPathToFloppy() . $HTTP_POST_VARS["filename"];
}
else if ($HTTP_POST_VARS["saveLocation"] == "diskonkey")
{  
  if ($os == "Linux" || $os == "Unix")
    ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", "<systemCall>mount /mnt/diskonkey</systemCall>", $returnString, $systemCallError);
  $fileP = "/mnt/diskonkey" . $HTTP_POST_VARS["filename"];
}
else if ($HTTP_POST_VARS["saveLocation"] == "usb")
{
  $fileP = "/mnt/usb/" . $HTTP_POST_VARS["filename"];
}
else
  $fileP = $_SESSION["diagsDirectory"] . $HTTP_POST_VARS["filename"];

if (file_exists($fileP))
{
  $oss = $oss . sprintf("if  (!window.confirm('%s'))\n{", TR("MSG_OVERWRITE_FILE_YES_NO"));
  $oss = $oss . sprintf("    \n  document.diagnosisResultForm.save.value=0;\n");
  $oss = $oss . sprintf("    document.diagnosisResultForm.submit();\n   }\n");
  $oss = $oss . sprintf("else\n");
  $oss = $oss . sprintf("{\n");
  $oss = $oss . sprintf("  document.diagnosisResultForm.saveLocation.value='%s';\n", $HTTP_POST_VARS["saveLocation"]);
  $oss = $oss . sprintf("  document.diagnosisResultForm.filename.value='%s';\n",$HTTP_POST_VARS["filename"]);
  $oss = $oss . sprintf("  saveFile(3);\n}\n");

}
else
{
  $oss = $oss . sprintf("  document.diagnosisResultForm.saveLocation.value='%s';\n", $HTTP_POST_VARS["saveLocation"]);
  $oss = $oss . sprintf("  document.diagnosisResultForm.filename.value='%s';\n",$HTTP_POST_VARS["filename"]);
  $oss = $oss . sprintf("  saveFile(3);\n");
} 
 
}
if ($HTTP_POST_VARS["save"] == "1") // keep savePrompt displayed
  $oss = $oss . sprintf("document.getElementById('savePrompt').style.display = 'inline';\ndocument.getElementById('savePrompt').style.visibility = 'visible';\n");
$oss = $oss . sprintf("</script>\n");
?>

<form name="diagnosisResultForm" action="diagnosisresult.php" method="POST">
        <div id='rootIt' style='left:100px; top:70px;Visibility:hidden; display:none;' name='rooty'>
          <div id='handleIt' width=100%> Save File</div>
          <div id='scrollContainerIt'>
<?php

//if (IsMounted("floppy"))
  printf("   <br>&nbsp;&nbsp;&nbsp;&nbsp;<input type='radio' name='location' id='floppylocation' value='floppy' checked> %s\n", TR("MSG_SAVE_TO_FLOPPY"));

if (IsOnline())
  printf("    <br>&nbsp;&nbsp;&nbsp;&nbsp;<input type='radio' name='location' id='hdrivelocation' value='harddrive'> %s %s<br>\n", TR("MSG_SAVE_TO_HARD_DRIVE"), $_SESSION["diagsDirectory"]);  

if (checkForUSBDevice("Transparent SCSI"))
{
  printf("                                 <br>&nbsp;&nbsp;&nbsp;&nbsp;<input type='radio' name='location' id='diskonkeylocation' value='diskonkey'> %s\n", TR("MSG_SAVE_TO_USB_KEY"));
  $diskonkey=true;
}

if (checkForUSBDevice("Floppy"))
{
  $usbFloppy = true;
  printf("                                 <br>&nbsp;&nbsp;&nbsp;&nbsp;<input type='radio' name='location' id='usblocation' value='usb'> %s\n", TR("MSG_SAVE_TO_USB_FLOPPY"));
}

printf("<br><table><tr><td valign=bottom>&nbsp;&nbsp;&nbsp;&nbsp;%s: <input type=text name=filename value='diagnosisresult.html' onKeyPress='return submitenter(\"2\");'> </td>", TR("MSG_FILENAME"));
printf("<td>&nbsp;&nbsp;\n%s</td><td valign=top>&nbsp;&nbsp;%s\n</td></tr></table>", MakeButton(TR("MSG_SAVE"),"saveFile('2');",""), MakeButton(TR("MSG_CANCEL"),"document.getElementById('rootIt').style.display = 'none';document.getElementById('rootIt').style.visibility = 'hidden';",""));
?>
    <div id='scrollContentIt'></div>
  </div>
</div>
<input type=hidden name=save value=0>
<input type=hidden name=saveLocation value='floppy'>
  <!-- put here to avoid js runtime errors -->
  <div style="visibility:hidden;display:none" id="jobLoop"></div><div style="visibility:hidden;display:none" id="verlocation"></div><div style="visibility:hidden;display:none" id=stateMessage></div><div style="visibility:hidden;display:none" id=overallPercent></div><div style="visibility:hidden;display:none" id=cancel-retest></div><div style="visibility:hidden;display:none" id="tests"></div></form>
  

<?php
//printf("<div id='wait' style='Visibility:Visible; display:inline;'><center><br>%s<br><img src='hourglassani.gif'></center></div>", TR("MSG_PLEASE_WAIT"));
//hidden variables
//printf("<script language='Javascript'>\ndocument.getElementById('wait').style.visibility='hidden';\ndocument.getElementById('wait').style.display='none';\n</script>");
printf("%s", $oss);
?>



</body></html>
