<?php
session_start();

include "iocommand.php";
include "fefunctions.php";
$oss = "";
if ($_REQUEST["surveyLevel"] != "") // do not clear the survey Level - it will only be clear on inital load
  $_SESSION["surveyLevel"] = $_REQUEST["surveyLevel"];  

if ($_REQUEST["category"] != "")
  $_SESSION["currentCategory"] = $_REQUEST["category"];

printf("<html>\n  <head>\n  <meta http-equiv='content-type' content='text/html; charset=UTF-8'>\n");

printf("  <title>HP Insight Diagnostics</title>\n  <link rel='stylesheet' type='text/css' href='stylesheets/main.css'>\n<link rel='stylesheet' type='text/css' href='stylesheets/header.css'>\n");

printf("</head><body><form name='surveyContentForm' method=post>");

printf("<input type=hidden name=save value='2'><input type=hidden name=saveLocation value='floppy'><input type=hidden name='filename' value=''>");

if ($HTTP_POST_VARS["save"] == "2")  // check if file exits
{
  printf("<script language='Javascript'>\n");

  if ($HTTP_POST_VARS["saveLocation"] == "floppy")
  {
    if ($os == "Linux" || $os == "Unix")
      ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", "<systemCall>mount " . getPathToFloppy() . "</systemCall>", $returnString, $systemCallError);
    $fileP = getPathToFloppy() . $HTTP_POST_VARS["filename"];
  }
  else if ($HTTP_POST_VARS["saveLocation"] == "diskonkey")
  {
    if ($os == "Linux" || $os == "Unix")
      ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", "<systemCall>mount /mnt/diskonkey</systemCall>", $returnString, $systemCallError);
    $fileP = "/mnt/diskonkey" . $HTTP_POST_VARS["filename"];
  }
  else if ($HTTP_POST_VARS["saveLocation"] == "usb")
  {
    $fileP = "/mnt/usb/" . $HTTP_POST_VARS["filename"];
  }
  else
    $fileP = $_SESSION["diagsDirectory"] . $HTTP_POST_VARS["filename"];

  if (file_exists($fileP))
  {
    printf("if  (!window.confirm('%s'))\n{",TR("MSG_OVERWRITE_FILE_YES_NO"));
    printf("    \n  document.surveyContentForm.save.value=0;\n");
    printf("    document.surveyContentForm.submit();\n   }\n");
    printf("else\n");
    printf("{\n");
    printf("  document.surveyContentForm.saveLocation.value='%s';\n", $HTTP_POST_VARS["saveLocation"]);
    printf("  document.surveyContentForm.filename.value='%s';\n",$HTTP_POST_VARS["filename"]);
    printf("  parent.parent.frames.dataFrame3.saveFile(3);\n}\n");
  }
  else
  {
    printf("  document.surveyContentForm.saveLocation.value='%s';\n", $HTTP_POST_VARS["saveLocation"]);
    printf("  document.surveyContentForm.filename.value='%s';\n",$HTTP_POST_VARS["filename"]);
    printf("  parent.parent.frames.dataFrame3.saveFile(3);\n");
  } 
  printf("</script>\n");
}

printf("<div id='wait' style='Visibility:Visible; display:inline;'><center><br>%s<br><img src='hourglassani.gif'></center></div>", TR("MSG_PLEASE_WAIT"));

if ($HTTP_POST_VARS["save"] != "2")
{
  $idXml = new DomDocument($_SESSION["idResult"]);


  $idXpath = @xpath_new_context($idXml->document_element());

  // get the surveyTimeStamp from the idResult
  $diagOutputs = @xpath_eval($idXpath, "/diagOutput");
  if (count($diagOutputs->nodeset) > 0)
  {
    $_SESSION["surveyTimeStamp"] = @$diagOutputs->nodeset[0]->get_attribute("timeStamp");
  }
  
  if ($_SESSION["currentCategory"] == "" || $_SESSION["currentCategory"] == "All")
    $categories = @xpath_eval($idXpath, "/diagOutput/category");  // get ALL the category objects
  else
    $categories = @xpath_eval($idXpath, "/diagOutput/category[@name='" . $_SESSION["currentCategory"] . "']");  // get specific category object
  set_time_limit(270);



  $oss = $oss . sprintf("<table width=100%% bgcolor=white border=0 cellspacing=0 cellpadding=0 style='border-left: 2px #968f89 solid;border-right: 2px #968f89 solid;border-bottom: 2px #968f89 solid;'>\n");
  $num_cats = count($categories->nodeset);
  for($c=0; $c < $num_cats; $c++)
  {
    $cat = $categories->nodeset[$c];
    $depth = 0; // xml tree depth
    if ($_SESSION["currentCategory"] == "" || $_SESSION["currentCategory"] == "All")
    {
      outputTableContent($oss, $cat, $depth, $bgcolor);
    }
    else
    {
      $objXpath = @xpath_new_context($cat);
      $nestedObjects = @xpath_eval($objXpath, "/*");
      foreach ($nestedObjects->nodeset as $nestedObj)
      {
        outputTableContent(&$oss, $nestedObj, $depth, $bgcolor);
      }
    }
  }
  $oss = $oss . sprintf("</tabe>\n");
}



printf("%s", $oss);

if ($HTTP_POST_VARS["save"] == "3")  
{ // Save page

  $result = SaveFile($HTTP_POST_VARS["filename"],$HTTP_POST_VARS["saveLocation"], "HP Insight Diagnostics " . TR("MSG_VERSION") . " " . getBuildVersion() . "<br>" . TR("Computer Name") . ": " . getComputerName() . $oss);
  
  printf("<script language='Javascript'>\n");
  if ($result == 1 || $result == 3)
    printf("alert('%s - %s');\n", TR("MSG_WRITEERROR"), TR("MSG_PLEASE_INSERT_FLOPPY"));
  else if ($result == 2)
    printf("alert('%s - %s');\n", TR("MSG_WRITEERROR"), TR("MSG_DISK_FULL"));
  else if ($result == 4)
    printf("alert('%s - %s');\n", TR("MSG_WRITEERROR"), TR("MSG_BAD_FORMAT"));
  else
  {
    printf("parent.parent.frames.dataFrame3.document.getElementById('rootIt').style.display = 'none';\n");
    printf("parent.parent.frames.dataFrame3.document.getElementById('rootIt').style.visibility = 'hidden';\n");
    printf("alert('%s');\n", TR("MSG_FILE_WRITE_COMPLETE"));
  }
  printf("parent.parent.frames.dataFrame3.document.getElementById('filename').value = 'survey.html';\n</script>\n");
  
}		

printf("<script language='Javascript'>\ndocument.getElementById('wait').style.visibility='hidden';\ndocument.getElementById('wait').style.display='none';\n</script>");

?>
</form>
<script language="Javascript" src="norightclick.js"></script></body>
</html>