<?php
session_start();

   /***********************************************************************
   *    Copyright  2002 - 2005 Hewlett-Packard Development Company, L.P. *
   ***********************************************************************/
   
$_SESSION["diagsDirectory"] = "\\hp\\hpdiags\\";   

$_SESSION["statusDrawn"] = "false";
$_SESSION["page"] = "status.php";
include "iocommand.php";
include "fefunctions.php";

if ($_SESSION["testpid"] != "" && $HTTP_POST_VARS["device"] != "" && $HTTP_POST_VARS["test"] != "" && $HTTP_POST_VARS["component"] != "" && $HTTP_POST_VARS["selection"] != "")  // prompt submitted?
{ // prompts submited correctly
  $ps = 1;
  printf("%s", $test);
  $promptStatus = "";
  $promptErrors = "";
  $promptResponse = sprintf("<sendProcessReply processID='%s'><promptResponse component='%s' device='%s' test='%s' value='%s'>%s</promptResponse></sendProcessReply>", $_SESSION["testpid"], $HTTP_POST_VARS["component"], $HTTP_POST_VARS["device"],$HTTP_POST_VARS["test"],$HTTP_POST_VARS["selection"], $HTTP_POST_VARS["selection"]);
  ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $promptResponse, $promptStatus, $promptErrors);
  //printf("<script language='Javascript'>\nalert('hi');\nsetTimeout(\"document.location = 'xdemo.php'\",2000);</script>\n");
  

}
else if ($HTTP_POST_VARS["retest"] == "1")
{
  // Submit the diagRun command					  
  $runErrors = "";
  $runStatus = "";
  $diagRunStr = $_SESSION["diagRun"];
  ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $diagRunStr, $runStatus, $runErrors);
  $xmldoc = new DomDocument($runStatus);

  // zero out all the globals since we are going to test again
    
  $rootElement = $xmldoc->document_element();
  $_SESSION["testpid"] = $rootElement->get_attribute("processID");
  printf("<script language='Javascript'>\ndocument.location = 'xdemo.php';</script>\n");
}
else if ($HTTP_POST_VARS["cancelPid"] == $_SESSION["testpid"] && $_SESSION["testpid"] != "")
{
  // Cancel Tests
  $cancelCommand = sprintf("<cancelProcess processID='%s' />", $_SESSION["testpid"]);
  ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $cancelCommand, $testStatus, $testErrors);  
}

?>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
<title>HP Insight Diagnostics</title>
<script language="javascript" src="dom-drag.js"></script>
<link rel='stylesheet' type='text/css' href='stylesheets/main.css'>
<script language="javascript"  type="text/javascript">
var lastPromptID;
var IsFactory;
var statusDrawn = false;
var writeStringCreated = false;
var lastLoop = "0";
var completedTests = new Array();
<?php 
if (IsFactory())
  printf("IsFactory = true;\n");
else
  printf("IsFactory = false;\n");
?>

  function sendPrompt(device, test, component, selection)
  {
    //alert(device+" "+test+" "+component+" "+selection);
	  document.promptForm.device.value = device;
	  document.promptForm.test.value = test;
	  document.promptForm.component.value = component;
	  document.promptForm.selection.value = selection;
	  document.promptForm.submit();
    document.getElementById('rootIt').style.display = 'none';
    document.getElementById('rootIt').style.visibility = 'hidden';
    document.getElementById('cancel-retest').style.visibility = 'visible';
  }

  function getKeyPress(code)
  {
    var keycode;
    if (window.event)
      keycode = window.event.keyCode;
    else if (code)
      keycode = code.which;

    switch (keycode)
    {
      case 89: buttonYes.click(); break
      case 78: buttonNo.click(); break
      case 67: buttonCancel.click(); break
      case 79: buttonOK.click(); break;
      case 48: case 96: button0.click(); break
      case 49: case 97: button1.click(); break
      case 50: case 98: button2.click(); break
      case 51: case 99: button3.click(); break
      case 52: case 100: button4.click(); break
      case 53: case 101: button5.click(); break
      case 54: case 102: button6.click(); break
    }

  }

var url = "getStatus.php"; // The server-side script

function getHTTPObject() 
{
  var xmlhttp;
  /*@cc_on
  @if (@_jscript_version >= 5)
    try 
    {
      xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
    } 
    catch (e) 
    {
      try 
      {
        xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
      } 
      catch (E) 
      {
        xmlhttp = false;
      }
    }
  @else
  xmlhttp = false;
  @end @*/
  
  if (!xmlhttp && typeof XMLHttpRequest != 'undefined') 
  {
    try 
    {
      xmlhttp = new XMLHttpRequest();
	    xmlhttp.overrideMimeType("text/xml"); 
    } 
    catch (e) 
    {
      xmlhttp = false;
    }
  }
  return xmlhttp;
}


function handleHttpResponse() 
{
  if (http.readyState == 4) 
  {
    //if (http.responseText.indexOf('invalid') == -1) 
    // if "OK"
    if (http.status==200)
    {
      // Use the XML DOM to unpack the city and state data 
      var xmlDocument = http.responseXML;
      
      var overallObj = xmlDocument.getElementsByTagName('processStatus').item(0);
      if (overallObj)
      {
        var rowColor = "", stateMessage = "", stateMessage, testsComplete = "", updateTimer, loopCaption = "", overallTestTimeCaption = "";;
        var overallCaption = overallObj.getAttribute("caption");
        if (!overallCaption)
          overallCaption = "";
        var overallPercent = overallObj.getAttribute("percentComplete");
        if (!overallPercent)
          overallPercent = "-1";
        var product = overallObj.getAttribute("product");
        if (product)
          overallCaption = overallCaption + "<br>" + product;
        var overallState = overallObj.getAttribute("state");
        if (!overallState)
          overallState = "";
        var cancelByTimeout = overallObj.getAttribute("testsCanceledByTestTime");
        if (!cancelByTimeout)
          cancelByTimeout = "";
        var currentLoop = overallObj.getAttribute("currentLoop");
        if (!currentLoop)
          currentLoop = "0";
        var testLoops = overallObj.getAttribute("testLoops");
        if (!testLoops)
          testLoops = "0";
        var totalTests = overallObj.getAttribute("totalTests");
        if (!totalTests)
          totalTests = "0";
        var testsFinished = overallObj.getAttribute("testsFinished");
        if (!testsFinished)
          testsFinished ="0";
        var desiredTestTime = overallObj.getAttribute("desiredTestTime");
        if (!desiredTestTime)
          desiredTestTime ="0";
        var overallTestTime = overallObj.getAttribute("testTime");
        if (!overallTestTime)
          overallTestTime = "0";        
          
        loopCaption = "<?php echo TR("MSG_CURRENT_LOOP") . ': '; ?>" + currentLoop;
        if (testLoops != "0")
          loopCaption = loopCaption + "<?php echo TR("MSG_OF"); ?>" + " " + testLoops;
        loopCaption = loopCaption + "&nbsp;&nbsp;&nbsp;&nbsp;";
        
        overallTestTimeCaption = "<?php echo TR("MSG_TEST_TIME"); ?>" + ": " + overallTestTime;  
        if (desiredTestTime != "0")
        overallTestTimeCaption = overallTestTimeCaption  + "<?php echo ' ' . TR("MSG_OF"); ?>" + " " + desiredTestTime;
        
        if (overallState == "running")
        {
          stateMessage = "<?php echo TR("MSG_TESTING_IN_PROGRESS"); ?>";
          document.getElementById('cancel-retest').innerHTML = '<?php echo MakeButton(TR("MSG_CANCEL_TESTING"), "document.cancelTestingForm.submit();"); ?>';
        }
        else if (overallState == "canceling")
        {
          stateMessage = "<?php echo TR("MSG_CANCELING"); ?>";
        }
        else if (overallState == "canceled")
        {
          stateMessage = "<?php echo TR("MSG_TEST_CANCELED"); ?>";
          document.getElementById('cancel-retest').innerHTML = '<?php echo MakeButton(TR("MSG_RETEST"), "document.retestForm.submit();"); ?>';
        }
        else if (overallState == "completed")
        {
          if (cancelByTimeout)
            stateMessage = "<?php echo TR("MSG_TEST_TIMEOUT_CANCEL"); ?>";
          else
            stateMessage = "<?php echo TR("MSG_TESTING_COMPLETED"); ?>";
            
          document.getElementById('cancel-retest').innerHTML = '<?php echo MakeButton(TR("MSG_RETEST"), "document.retestForm.submit();"); ?>';
        }
        else if (overallState == "crashed")
        {
          stateMessage = "<?php echo TR("MSG_ABNORMAL_TERMINATION"); ?>";
        }
        else
        {
          stateMessage = "<?php echo TR("MSG_NO_TESTS_RUNNING"); ?>";
        }
        
        // reset and redraw after each loop
        //alert(currentLoop + " != " + lastLoop);
        if (currentLoop != lastLoop)
        {
          lastLoop = currentLoop;
          statusDrawn = false;
          for (var x = 0; x < totalTests; x++) 
          { 
            completedTests[x] = "0"; 
          }
        }        
              
        document.getElementById('jobCaption').innerHTML = "&nbsp;&nbsp;" + overallCaption;
        document.getElementById("stateMessage").innerHTML = stateMessage;
        document.getElementById("overallPercent").innerHTML = "<center><b>" + overallPercent + "%</b></center>";
        document.getElementById("overallPercent").style.width = overallPercent + "%";
        
        if (IsFactory)
          testsComplete = "<?php echo TR("MSG_TEST"); ?>" + " " + "<?php echo TR("MSG_COMPLETE"); ?>" + ": " + testsFinished + " " + "<?php echo TR("MSG_OF"); ?>" + " " + totalTests;
          
        document.getElementById('jobLoop').innerHTML = loopCaption + " " + overallTestTimeCaption + " &nbsp;&nbsp;&nbsp;&nbsp;" + testsComplete;
          
        if (!statusDrawn)
        {
          var store = new Array();
          document.getElementById("tests").innerHTML = "";
          store.push("<table width=100%>");
        }
        
        var processStatusArr = xmlDocument.getElementsByTagName('processStatus');
        
        for (var i = 1; i < processStatusArr.length; i++)
        {
          //var processStatusObj = xmlDocument.getElementsByTagName('processStatus').item(i);
          var processStatusObj = processStatusArr.item(i);
          var device = processStatusObj.getAttribute("device");
          var test = processStatusObj.getAttribute("test");
          var state = processStatusObj.getAttribute("state");
          var percentComplete = processStatusObj.getAttribute("percentComplete");
          if (!percentComplete)
            percentComplete = "0";
          var caption = processStatusObj.getAttribute("caption");
          var description = processStatusObj.getAttribute("description");
          var testTime = processStatusObj.getAttribute("testTime");
          if (!testTime)
           testTime = "";
          var component = processStatusObj.getAttribute("component");
          var operationCaption = processStatusObj.getAttribute("OperationCaption");
          var gif = "unknown.gif";
        
          var diagPromptArr = processStatusObj.getElementsByTagName("diagPrompt");
          if (diagPromptArr.length)
          {
            var diagPrompt = diagPromptArr.item(0);
            var promptID = diagPrompt.getAttribute("promptID");
            var diagPromptChild = diagPromptArr.item(0).firstChild;
            var content = diagPromptChild.nodeValue;          
            if (content.indexOf('\n')) // remove any carriage returns
              content = content.replace("\n", "");
            
            if (promptID != lastPromptID)
            {
              lastPromptId = promptID;
            
              var titleCaption = diagPrompt.getAttribute("titleCaption");
              if (titleCaption != "")
                caption = titleCaption;
            
              var promptContents = "<center>" + content + "<br><br>";
            
              var type = diagPrompt.getAttribute("type");
              if (type == "text")
              {
                promptContents = promptContents + "<input type='text' name='promptText' size='20' id='promptText'><input type='button' value=\"<?php echo TR('MSG_OK');?>\" onclick=sendPrompt(\"" + device + "\",\"" + test + "\",\"" + component + "\",\"document.getElementById('promptText').value\");>&nbsp";
              }
              else //its a button
              {
                document.onkeydown = getKeyPress;
              
                if (titleCaption == "<?php echo TR("MSG_SUPERLED_TEST"); ?>")
                  promptContents = promptContents + "<table>";
                  
                var optionArr = diagPrompt.getElementsByTagName("option");
                for (var o=0; o < optionArr.length; o++)
                {
                  var option = optionArr.item(o);
                  var optionCaption = option.getAttribute("caption");
                  
                  var image = option.getAttribute("image");
                  var hotkey = option.getAttribute("hotkey");
                  
                  var firstButton;
                  if (o == 0)
                  {
                    if (hotkey != "" && titleCaption == "<?php echo TR("MSG_SUPERLED_TEST"); ?>")
                      firstButton = hotkey;
                    else
                      firstButton = optionCaption;
                  }
                  
                  if (image != "" && titleCaption == "<?php echo TR("MSG_SUPERLED_TEST"); ?>")
                    promptContents = promptContents + "<td id='button" + hotkey + "'align=center valign=center onclick=sendPrompt('" + device + "','" + test + "','" + component + "'," + o + ");><img src='" +  image + "'>";
                  else
                    promptContents = promptContents + "<td align=center valign=center onclick=sendPrompt('" + device + "','" + test + "','" + component + "'," + o + ");>";

	                if (titleCaption == '<?php echo TR("MSG_SUPERLED_TEST"); ?>')
                  {
                    promptContents = promptContents + "<BR>(" + hotkey + ") " + optionCaption + "</td>";

                    if (!(o%4)&& o != 0) // only have 4 images per table row
                      promptContents = promptContents + "</tr><tr>";
                  }
                  else
                    promptContents = promptContents + "<input type=button id=\"button" + optionCaption + "\" name=\"button" + optionCaption + "\" value=\"" + optionCaption + "\" onclick=sendPrompt(\"" + device + "\",\"" + test + "\",\"" + component + "\"," + o + ");>&nbsp";                    
                }

                if (titleCaption == "<?php echo TR("MSG_SUPERLED_TEST"); ?>")
                  promptContents = promptContents + "</table>";
                  
              } //end else button
            
              if (IsFactory)
                promptContents = "<font size=3>" + promptContents + "</font>";
              
              promptContents = promptContents + "</center>";
              document.getElementById('cancel-retest').style.visibility = 'hidden';
              document.getElementById('handleIt').innerHTML = caption;
              document.getElementById('scrollContentIt').innerHTML = promptContents;
              document.getElementById('rootIt').style.display = 'inline';
              document.getElementById('rootIt').style.visibility = 'visible';
              if (type == "text")
                document.getElementById('promptText').focus();
              else
                document.getElementById('button'+firstButton).focus();
              
            } //end if not last promptID
          } // end if we have a diagPrompt.length
          
          if (state == "waiting")
            percent = "0";

          if (state == "completed")
          {
            state = processStatusObj.getAttribute("result");
            if (state == "passed")
            {
              stateCaption = "<?php echo TR("MSG_PASSED"); ?>";
              gif = "ok.gif";
            }
            else if (state == "failed")
            {
              state = "<?php echo TR("MSG_FAILED"); ?>";
              gif = "failed.gif";
            }
            else
            {
              state = "";
              gif = "unknown.gif";
            }
          }
          else if (state == "crashed")
          {
            state = "<?php echo TR("MSG_ABNORMAL_TERMINATION"); ?>";
            gif = "failed.gif";
          }
          
          if (operationCaption)
            state = state + ": " + operationCaption;
            
          //have we already drawn out all the id objects?
          if (!statusDrawn)
          {
            writeStringCreated = true;
            store.push("<tr bgcolor='" + rowColor + "'>");
            store.push("<td width=41%><img id='gif" + i + "' src='" + gif + "'>&nbsp;&nbsp;<span id='caption" + i +"'>" + caption + "</span></td>");
            store.push("<td width=35% id='state" + i + "'>" + state + "</td>");
            store.push("<td width=16%><div style='border:thin inset; width:100%'><div id='progress" + i +"' style='background-color:#3399CC;width:" + percentComplete + "%'><center><b>" + percentComplete + "%</b></center></div></td>");
            store.push("<td  id='testTime" + i +"'>" + testTime + "</td></tr>");
            
            if (rowColor == "")
              rowColor = "#eeeeee";
            else
              rowColor = "";
          }
          else //if (completedTests[i] != "1")
          { // only update test status' that need to be updated - otherwise - don't waste time
            
            if (state != "running" && state != "waiting" && state != "" && gif != "unknown.gif")
            {
              completedTests[i] = "1";
            }
              
            var current_gif = document.getElementById('gif'+i).src;
            var percentComp = document.getElementById("progress" + i).style.width;
            var current_state = document.getElementById("state" + i).innerHTML;
            if ((percentComp != percentComplete + "%") || (current_gif.indexOf(current_gif) == -1) || (current_state.indexOf(state) == -1))
            {
              document.getElementById("gif" + i).src = gif;
              document.getElementById("state" + i).innerHTML = state;
              document.getElementById("progress" + i).style.width = percentComplete + "%";
              document.getElementById("progress" + i).innerHTML = "<center>" + percentComplete + "%</center>";
              document.getElementById("testTime" + i).innerHTML = testTime;
            }
          }         
        } //end processStatus for loop
        
        if (!statusDrawn && processStatusArr.length && overallPercent != "-1" && writeStringCreated)
        { 
          store.push("</table>");
          var writestring = store.join("");
          document.getElementById("tests").innerHTML = writestring;
          statusDrawn = true;
        }
      } // end if overallObj
      //else
        //                                        ("overallObj is null");
      isWorking = false;
    }
  }
}

var isWorking = false;
function updateState() 
{
  
  http = getHTTPObject(); // We create the HTTP Object
  if (!isWorking && http) 
  {
    http.open("GET", url + "?time=" + new Date().getTime(), true);
    http.onreadystatechange = handleHttpResponse;
    isWorking = true;
    http.send(null);
  }
  isWorking = false;
  setTimeout('updateState()', 2000)
}

var http;

  function initPage()
  {
	  theHandle = document.getElementById("handleIt");
	  theRoot   = document.getElementById("rootIt");
	  Drag.init(theHandle, theRoot);
    //parent.frames.updateStatusFrame.location.href='updatestatus.php';
    updateState();

  }

</script>
</head>
<body onload="initPage();" TOPMARGIN=0 MARGINHEIGHT=0>
<form name=retestForm method=POST>
<input type=hidden name=retest value="1">
</form>
<form name='cancelTestingForm' method=post>
<?php
if ($_SESSION["testpid"] != "")
  printf("<input type=hidden name='cancelPid' value='%s'>\n", $_SESSION["testpid"]);
?>
</form>
<form name='promptForm' method='POST'>
<input type=hidden value='' name='device'>
<input type=hidden value='' name='test'>
<input type=hidden value='' name='selection'>
<input type=hidden value='' name='component'>
</form>


<div id='rootIt' style='left:20px; top:20px;Visibility:hidden; display:none;' name='rooty'>
  <div id='handleIt' width=100%> </div>
  <div id='scrollContainerIt'>  
    <div id='scrollContentIt'></div>
  </div>
</div>


<table border=0 cellspacing=0 cellpadding=0 width='100%' height=100% bgcolor=white>
  <tr>
    <td width=15>
    </td>
    <td valign=top>
    
    
<table width=100% border=0 cellspacing=0 cellpadding=0>
<tr>
<td width=6 bgcolor=#cccccc></td><td width=5 bgcolor=white></td><td valign=top>

  <table cellspacing='0' cellpadding='0' border='0' width='100%' height=420>
    <tr>
      <td bgcolor=white id='jobCaption'></td>
      </td>
    </tr>
    <tr>
      <td align=left valign=top>
	
        <table width=650>
          <tr>
            <td align=center width=500 id='stateMessage'><b></b><br></td>
          </tr> 
          <tr>
            <td width=500>
              <div style='border:thin inset; width:100%;' id>
                <div id='overallPercent' style='background-color:#3399CC; width:0%'>
                  <center><b>0%</b></center>
                </div>
              </div>
            </td>
            <td width=150 id='cancel-retest'></td>
          </tr>
        </table>

        <table width=100%>
          <tr>
            <td id='jobLoop'></td>
          </tr>
        </table>

        <table cellspacing=0 cellpadding=0 width=100%>
          <tr class=heading>
<?php
  printf("    <td class=heading width=40%%>%s, %s</td>\n", TR("MSG_DEVICE"), TR("MSG_TEST"));
  printf("    <td class=heading width=35%%>%s</td>\n", TR("MSG_STATUS"));
  printf("    <td class=heading width=15%%>%s</td>\n", TR("MSG_TEST_PROGRESS"));
  printf("    <td class=heading width=10%%>%s</td>\n", TR("MSG_TEST_TIME"));
  printf("  </tr>\n</table>\n\n<table width=100%% cellspacing=0 cellpadding=0 style='border-left: 2px #968f89 solid;border-right: 2px #968f89 solid;border-bottom: 2px #968f89 solid;'><tr><td>");

  if (IsPhoenix())
    printf("<div style='height:400px;overflow:auto' id='tests'>\n</div>\n");
  else
    printf("<div style='height:290px;overflow:auto' id='tests'>\n</div>\n");
?>

        </td>
      </tr>
    </td>
  </tr>
</table>






          </td>
        </tr>
      </table>
    </td>
    <td width=5 bgcolor=white></td>
    <td bgcolor=#cccccc width=6></td>
    <td width=10></td>
  </tr>
  <tr>
    <td bgcolor=#cccccc height=5></td>
    <td width=5 colspan=3></td>
    <td bgcolor=#cccccc width=5></td>
  </tr>
  <tr>
    <td bgcolor=#cccccc width=5 colspan=5 height=5></td>
  </tr>
  <tr>
    <td colspan=5 height=5></td>
  </tr>
  <tr>
    <td colspan=5 height=10>


    </td>
  </tr>
</table>

</body>

</html> 

