<?php
	session_start();
	
	// Added for unicode support.
	header('Content-Type: text/html; charset=UTF-8');  

	// Used by demo - move it along with demo mode
	$location = $_REQUEST['location'];
	if ( isset ( $location ) )
	 	$_SESSION['location']=$location;
?>

<?php

	 // NOTE : Don't combine this include / require constant statement 
	 //		with other ones. It is most desirable that checking for
	 //		xml ftp functionality is performed, before anything else
	 //		is performed - Imran Salim
	 require_once("../Util/Constant.php");
	 require_once(CONST_DIR_DATA_PROTECTION()."/Xml/UpdateContent.php");
	
?>

<?php
	require_once( CONST_DIR_DATA_PROTECTION()."/Compound/Page.php");
	$Page = new Page("Nearline Data Protection", null);
	$Page->BuildFromXml(); 	// TODO : BuildFromXml should be called from init method, and 
							//			init() method should be called here
?>

<link rel="stylesheet" type="text/css" href="../StyleSheet.css" />

<center>

	<?php $frmAction = $_SERVER['PHP_SELF'] ?>
	<!--  onClick="OnDocumentClick();" onLoad="OnDocumentLoad();" onSubmit="OnDocumentSubmit();" -->
	<form name=<?php print ( CONST_FORM_MAIN() ) ?> action=<?php print($frmAction) ?> method="POST" onClick="OnDocumentClick();">
		<a name="Top" />
		<div id="mainLayout">
			<table border="0" width="100%" cellpadding="5">
				<tr>
					<td align="left" width="5%">
						<img src="/DataProtection/Image/HpLogo72.png"></img>
					</td>
					<td align="left" valign="top" width="65%">
						<!-- font-size of 24px for heading is part of spec -->
						<div class="PageHeadingStyle"><?php print($Page->Title) ?> for [<?php  print ( $_SERVER['SERVER_NAME'] );  ?>]</div>
						<div class="PageSubHeadingStyle"><?php print($Page->SubTitle) ?></div>
					</td>
					<td width="20%" valign="top" align="right" nowrap>
						<div class="HeaderLastUpdateStyle">
							Last Update : <?php print ( $Page->LastUpdate ); ?>
						</div>
					</td>
				</tr>
			</table>
			<hr/>
			<table cellpadding="7">
				<tr>
					<td class="NavigationLeftStyle" width="20%" <?php /* non ie related attributes */ if ( BrowserPlatform()!="InternetExplorer" ) print(  " bgcolor='#00659C'" ); ?> >
						<!-- div style="font-weight:bold;">Protect Your Data</div -->
						<!--
						<div><a href='BackupSoftware.php'><font color=white>Backup and Restore</font></a></div>
						<div><a href='TapeAnalysis.php'><font color=white>Tape Utility</font></a></div>
						-->
						<?php
							$Page->DocumentNavigationBar->Display();
						?>
						<br/>
						<?php
							$Page->LeftNavigationBar->Display();						
						?>
					</td>
					<td>
						<?php
							foreach ( $Page->Controls as $pageControl )
							{
								$pageControl->Display();
								print ( "<hr/>" );
							}
						?>
					</td>
					<td><!--Right Area--></td>
				</tr>
			</table>
			<table width="100%">
				<tr>
					<td width="50%">
					</td>
					<td width="50%" align="right">
						<!-- Right Hand Size footer content - copyright etc			 -->
						<div id="bottomArea" class="FooterDisclaimerStyle" align="right">
							&#169; 2005 Hewlett-Packard Development Company, L.P.
						</div>
					</td>
				</tr>
			</table>
			<hr/>
			<!-- ----------------------------------------------------- 
						Demo mode handling
			----------------------------------------------------- -->
			<?php
				if ( $_SESSION["Mode"]=="Demo" )
				{
					?>
						<div align="right">
							<a href="/<?php print ( CONST_DATAPROTECTION() ); ?>/Compound/Default.php?location=local">Set Local Demo</a><br/>
							<a href="/<?php print ( CONST_DATAPROTECTION() ); ?>/Compound/Default.php?location=remote">Set Remote Demo</a>
						</div>
					<?php
				}
			?>
		</div>

		<!-- ----------------------------------------------- -->
		<!-- SCROLL BACK TO PREVIOUS LOCATION, AFTER REQUEST -->
		<!-- ----------------------------------------------- -->
		
		<script language="JavaScript" src="/<?php print ( CONST_DATAPROTECTION() ); ?>/Cookie.js">
		</script>
		
		<script language="JavaScript">

			function OnDocumentSubmit()
			{
				//
				// Does not work if links are used to 'emulate' submit
				//
			}
			
			function OnDocumentClick()
			{
				var scrollTop = document.body.scrollTop;
				var scrollLeft = document.body.scrollLeft;

				setCookie("ScrollTop", scrollTop, null, "", "", ""); 
				setCookie("ScrollLeft", scrollLeft, null, "", "", ""); 
				// setCookie(name, value, expires, path, domain, secure;
			}

			function OnDocumentLoad()
			{
				var scrollTop = getCookie("ScrollTop");
				var scrollLeft = getCookie("ScrollLeft");

				document.body.scrollTop = scrollTop;
				document.body.scrollLeft = scrollLeft;
			}
			
			OnDocumentLoad();
			
			// TODO : INVESTIGATE : Yhe statements below does not seem to be effective.
			// document.<?php print ( CONST_FORM_MAIN() ); ?>.onClick 	+= 	OnDocumentClick();
			// document.<?php print ( CONST_FORM_MAIN() ); ?>.onLoad 	+=	OnDocumentLoad();
			// document.<?php print ( CONST_FORM_MAIN() ); ?>.onSubmit	+=	OnDocumentSubmit();
		
		</script>

	</form>
</center>

<?php


 	// Update Xml Content using Lazy Load
	// NOTE : It is best to have update content at bottom, to build
	//			page completely, and then do any updates. Also, it is a 
	//			bug fix because if downloaded xml is locked, and 
	//			update control is in middle of this page, the 
	//			remaining portions will not render, thus causing bugs
	// 			spececially in JavaScript, becuase all scripts are
	//			not loaded by browser. - Imran Salim
	$updateClient = new UpdateContent("XmlUpdateClient", null);
	$updateClient-> __protected__OnResponse();
	
?>